import tools
from osv import osv, fields
import addons
import os
from tools import debug
import datetime
import calendar
import time
from datetime import timedelta, date

class report_stock_inventory(osv.osv):
	_inherit = "report.stock.inventory"
	_columns = {
		'price_unit' : fields.float('Precio unitario'),
	}
	
	def init(self, cr):
		tools.drop_view_if_exists(cr, 'report_stock_inventory')
		cr.execute("""
					CREATE OR REPLACE view report_stock_inventory AS (
						(SELECT
							min(m.id) as id,m.price_unit as price_unit, m.date as date,
							m.address_id as partner_id, m.location_id as location_id,
							m.product_id as product_id, pt.categ_id as product_categ_id, l.usage as location_type,
							m.company_id,
							m.state as state, m.prodlot_id as prodlot_id,
							coalesce(sum(-pt.standard_price * m.product_qty)::decimal, 0.0) as value,
							CASE when pt.uom_id = m.product_uom
							THEN
							coalesce(sum(-m.product_qty)::decimal, 0.0)
							ELSE
							coalesce(sum(-m.product_qty * pu.factor)::decimal, 0.0) END as product_qty
						FROM
							stock_move m
								LEFT JOIN stock_picking p ON (m.picking_id=p.id)
								LEFT JOIN product_product pp ON (m.product_id=pp.id)
									LEFT JOIN product_template pt ON (pp.product_tmpl_id=pt.id)
									LEFT JOIN product_uom pu ON (pt.uom_id=pu.id)
								LEFT JOIN product_uom u ON (m.product_uom=u.id)
								LEFT JOIN stock_location l ON (m.location_id=l.id)
						GROUP BY
							m.id, m.product_id, m.product_uom, pt.categ_id, m.address_id, m.location_id,  m.location_dest_id,
							m.prodlot_id, m.date, m.state, l.usage, m.company_id,pt.uom_id,m.price_unit
					) UNION ALL (
						SELECT
							-m.id as id,m.price_unit as price_unit, m.date as date,
							m.address_id as partner_id, m.location_dest_id as location_id,
							m.product_id as product_id, pt.categ_id as product_categ_id, l.usage as location_type,
							m.company_id,
							m.state as state, m.prodlot_id as prodlot_id,
							coalesce(sum(pt.standard_price * m.product_qty )::decimal, 0.0) as value,
							CASE when pt.uom_id = m.product_uom
							THEN
							coalesce(sum(m.product_qty)::decimal, 0.0)
							ELSE
							coalesce(sum(m.product_qty * pu.factor)::decimal, 0.0) END as product_qty
						FROM
							stock_move m
								LEFT JOIN stock_picking p ON (m.picking_id=p.id)
								LEFT JOIN product_product pp ON (m.product_id=pp.id)
									LEFT JOIN product_template pt ON (pp.product_tmpl_id=pt.id)
									LEFT JOIN product_uom pu ON (pt.uom_id=pu.id)
								LEFT JOIN product_uom u ON (m.product_uom=u.id)
								LEFT JOIN stock_location l ON (m.location_dest_id=l.id)
						GROUP BY
							m.id, m.product_id, m.product_uom, pt.categ_id, m.address_id, m.location_id, m.location_dest_id,
							m.prodlot_id, m.date, m.state, l.usage, m.company_id,pt.uom_id,m.price_unit
						)
					);
							""")
report_stock_inventory()

class purchase_requisition(osv.osv):
	_name = "purchase.requisition"
	_description="Purchase Requisition"
	_inherit = "purchase.requisition"
	_columns = {
		'warehouse_id': fields.many2one('stock.warehouse', 'Warehouse',required=True),        
	}
purchase_requisition()

class res_company(osv.osv):
	_name = "res.company"
	_description = 'Companies'
	_inherit = 'res.company'
	_order = 'name'
	_columns = {
		'prefix' : fields.char('Prefijo',size=10),
		#'productos' : fields.many2one('product.product','productos')
	}
res_company()

class product_product(osv.osv):
		
	
	def _get_default_code(self, cr, uid, ids, field_name, arg, context=None):
		try:
			v = {}
			for x in self.browse(cr, uid, ids, context=context):
				company = x.company_id
				debug(company.prefix)
				if company.prefix != None:
					v[x.id] = company.prefix +"-"+x.default_code
				else:
					v[x.id] = 'N/D' +"-"+x.default_code
			return v
		except:
			return 
	
	_inherit = "product.product"
	_columns = {
		'refPre' : fields.function(_get_default_code,type='char',method=True,string='Referencia'),
	}
	
product_product()

