# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import xml
import copy
from operator import itemgetter
import time
import datetime
from report import report_sxw
import tools
from tools import debug

class absencePerCompanyTotal(report_sxw.rml_parse):
	_name = 'report.hr_payroll_cr.absencePerCompanyTotal'
	def __init__(self, cr, uid, name, context):
		super(absencePerCompanyTotal, self).__init__(cr, uid, name, context=context)
		self.localcontext.update({ 
			'time': time,
			'loadRegisters':self._loadRegisters,
			'startDate': self._startDate,
			'endDate': self._endDate,
		})

	def _loadRegisters(self, form):
		company_id = form['company_id']
		#to store the answer
		answ = []
		#search for all the employees of the given company
		contracts = self.pool.get('hr.contract').search(self.cr, self.uid,[('company_id','=',company_id)], order='code')
		employee_list = []
		for contract_id in contracts:
			contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)#loads the contract register to store the contract name
			employee_list.append(contract.employee_id.id)
		employees = self.pool.get('hr.employee').search(self.cr, self.uid,[('id','in',employee_list)], order='surname1, surname2, name')
		absences = self.pool.get('hr_payroll_cr.absence').search(self.cr, self.uid,[('contract','in',contracts), ('date','>=',form['dateStart']), ('date','<=',form['dateEnd'])], order='date')
		if form['order'] == '1':
			for contract_id in contracts:
				contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)#loads the contract register to store the contract name
				employee = self.pool.get('hr.employee').browse(self.cr, self.uid, contract.employee_id.id) #loads the employee register to store the employee name
				contractCode = contract.code
				name = employee.surname1 + ' ' + employee.surname2 + ' ' + employee.name
				absences = self.pool.get('hr_payroll_cr.absence').search(self.cr, self.uid,[('contract','=',contract_id), ('date','>=',form['dateStart']), ('date','<=',form['dateEnd'])], order='date')
				justify_count = 0
				total_count = 0
				justify_amount = 0
				total_amount = 0
				#for each absence per contract
				for absence_id in absences:
					absence = self.pool.get('hr_payroll_cr.absence').browse(self.cr, self.uid, absence_id)#loads the absence register to store the absence data
					if(absence.justification):
						payment_per_contract_line_browse = self.pool.get('hr_payroll_cr.payment_per_contract_line').browse(self.cr, self.uid, absence.payment_per_contract_line.id)
						justify_count += 1
						justify_amount += payment_per_contract_line_browse.amount
					total_count += 1
				if(total_count != 0):
					#charge the absence register whit all the information
					registerAbsJust = {'name':name, 'contractCode':contractCode, 'justify':'Si', 'amount':justify_amount, 'count':justify_count}
					registerAbs = {'name':name, 'contractCode':contractCode, 'justify':'No', 'amount':'---', 'count':(total_count - justify_count)}
					#append the register to the answer
					answ.append(registerAbsJust)
					answ.append(registerAbs)
		elif form['order'] == '2':
			for employee_id in employees:
				contracts = self.pool.get('hr.contract').search(self.cr, self.uid,[('company_id','=',company_id),('employee_id','=',employee_id)], order='date_start, code')
				employee = self.pool.get('hr.employee').browse(self.cr, self.uid, employee_id) #loads the employee register to store the employee name
				name = employee.surname1 + ' ' + employee.surname2 + ' ' + employee.name
							
				for contract_id in contracts:
					contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)#loads the contract register to store the contract name
					contractCode = contract.code
					absences = self.pool.get('hr_payroll_cr.absence').search(self.cr, self.uid,[('contract','=',contract_id), ('date','>=',form['dateStart']), ('date','<=',form['dateEnd'])], order='date')
					justify_count = 0
					total_count = 0
					justify_amount = 0
					total_amount = 0
					#for each absence per contract
					for absence_id in absences:
						absence = self.pool.get('hr_payroll_cr.absence').browse(self.cr, self.uid, absence_id)#loads the absence register to store the absence data
						if(absence.justification):
							payment_per_contract_line_browse = self.pool.get('hr_payroll_cr.payment_per_contract_line').browse(self.cr, self.uid, absence.payment_per_contract_line.id)
							justify_count += 1
							justify_amount += payment_per_contract_line_browse.amount
						total_count += 1
					if(total_count != 0):
						#charge the absence register with all the information
						registerAbsJust = {'name':name, 'contractCode':contractCode, 'justify':'Si', 'amount':justify_amount, 'count':justify_count}
						registerAbs = {'name':name, 'contractCode':contractCode, 'justify':'No', 'amount':'---', 'count':(total_count - justify_count)}
						#append the register to the answer
						answ.append(registerAbsJust)
						answ.append(registerAbs)
		#return the list of absence	
		return answ
		
	def _startDate(self, form):
		date = form['dateStart']
		return str(date)
		
	def _endDate(self, form):
		date = form['dateEnd']
		return str(date)
		

report_sxw.report_sxw('report.hr_payroll_cr.absencePerCompanyTotal', 'hr_payroll_cr.absence', 'addons/hr_payroll_cr/report/absencePerCompanyTotal.rml', parser=absencePerCompanyTotal, header=False)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

