# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import xml
import copy
from operator import itemgetter
import time
import datetime
from report import report_sxw
import tools
from tools import debug

class extraHourPerCompany(report_sxw.rml_parse):
	_name = 'report.hr_payroll_cr.extraHourPerCompany'
	def __init__(self, cr, uid, name, context):
		super(extraHourPerCompany, self).__init__(cr, uid, name, context=context)
		self.localcontext.update({ 
			'time': time,
			'loadRegisters':self._loadRegisters,
			'startDate': self._startDate,
			'endDate': self._endDate,
			'get_company' : self._get_company,
		})
		
	def _loadRegisters(self, form):
		company_id = form['company_id']
		debug(company_id)
		#to store the answere
		answ = []
		#search for all the employees of the given company
		contracts = self.pool.get('hr.contract').search(self.cr, self.uid,[('company_id','=',company_id)], order='code')
		employee_list = []
		for contract_id in contracts:
			contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)#loads the contract register to store the contract name
			employee_list.append(contract.employee_id.id)
		employees = self.pool.get('hr.employee').search(self.cr, self.uid,[('id','in',employee_list)], order='surname1, surname2, name')
		debug(employees)
		extra_hours = self.pool.get('hr_payroll_cr.extra_hour').search(self.cr, self.uid,[('contract','in',contracts), ('date','>=',form['dateStart']), ('date','<=',form['dateEnd'])], order='date')
		if form['order'] == '1':
			for contract_id in contracts:
				contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)#loads the contract register to store the contract name
				contractCode = contract.code			
				employee = self.pool.get('hr.employee').browse(self.cr, self.uid, contract.employee_id.id) #loads the employee register to store the employee name
				name = employee.surname1 + ' ' + employee.surname2 + ' ' + employee.name
				
				extra_hours = self.pool.get('hr_payroll_cr.extra_hour').search(self.cr, self.uid,[('contract','=',contract_id), ('date','>=',form['dateStart']), ('date','<=',form['dateEnd'])], order='date')
				#for each extra_hour per contract
				for extra_hour_id in extra_hours:
					extra_hour = self.pool.get('hr_payroll_cr.extra_hour').browse(self.cr, self.uid, extra_hour_id)#loads the extra_hour register to store the extra_hour data
					payment_per_contract_line = self.pool.get('hr_payroll_cr.payment_per_contract_line').search(self.cr, self.uid, [('id','=',extra_hour.payment_per_contract_line.id)])
					if (payment_per_contract_line == []):
						register = {'name':name, 'contractCode':contractCode, 'amount_hours':extra_hour.hours, 'date':extra_hour.date, 'amount':'No Pagada'} 
					else:
						ppcl_browse = self.pool.get('hr_payroll_cr.payment_per_contract_line').browse(self.cr, self.uid, payment_per_contract_line[0])
						#charge the extra_hour register whit all the information
						register = {'name':name, 'contractCode':contractCode, 'amount_hours':extra_hour.hours, 'date':extra_hour.date, 'amount':ppcl_browse.amount } 
					#append the register to the answere
					answ.append(register)
		elif form['order'] == '2':
			for employee_id in employees:
				contracts = self.pool.get('hr.contract').search(self.cr, self.uid,[('company_id','=',company_id),('employee_id','=',employee_id)], order='date_start, code')
				employee = self.pool.get('hr.employee').browse(self.cr, self.uid, employee_id) #loads the employee register to store the employee name
				name = employee.surname1 + ' ' + employee.surname2 + ' ' + employee.name
							
				for contract_id in contracts:
					contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)#loads the contract register to store the contract name
					contractCode = contract.code
					extra_hours = self.pool.get('hr_payroll_cr.extra_hour').search(self.cr, self.uid,[('contract','=',contract_id), ('date','>=',form['dateStart']), ('date','<=',form['dateEnd'])], order='date')
					#for each extra_hour per contract
					for extra_hour_id in extra_hours:
						extra_hour = self.pool.get('hr_payroll_cr.extra_hour').browse(self.cr, self.uid, extra_hour_id)#loads the extra_hour register to store the extra_hour data
						payment_per_contract_line = self.pool.get('hr_payroll_cr.payment_per_contract_line').search(self.cr, self.uid, [('id','=',extra_hour.payment_per_contract_line.id)])
						if (payment_per_contract_line == []):
							register = {'name':name, 'contractCode':contractCode, 'amount_hours':extra_hour.hours, 'date':extra_hour.date, 'amount':'No Pagada'} 
						else:
							ppcl_browse = self.pool.get('hr_payroll_cr.payment_per_contract_line').browse(self.cr, self.uid, payment_per_contract_line[0])
							#charge the extra_hour register whit all the information
							register = {'name':name, 'contractCode':contractCode, 'amount_hours':extra_hour.hours, 'date':extra_hour.date, 'amount':ppcl_browse.amount }  
						#append the register to the answere
						answ.append(register)			
		else:
			#for each extra_hour per contract
			for extra_hour_id in extra_hours:
				extra_hour = self.pool.get('hr_payroll_cr.extra_hour').browse(self.cr, self.uid, extra_hour_id)#loads the extra_hour register to store the extra_hour data
				contract = self.pool.get('hr.contract').browse(self.cr, self.uid, extra_hour.contract.id)#loads the contract register to store the contract name
				contractCode = contract.code				
				employee = self.pool.get('hr.employee').browse(self.cr, self.uid, contract.employee_id.id) #loads the employee register to store the employee name
				name = employee.surname1 + ' ' + employee.surname2 + ' ' + employee.name
				payment_per_contract_line = self.pool.get('hr_payroll_cr.payment_per_contract_line').search(self.cr, self.uid, [('id','=',extra_hour.payment_per_contract_line.id)])
				if (payment_per_contract_line == []):
					register = {'name':name, 'contractCode':contractCode, 'amount_hours':extra_hour.hours, 'date':extra_hour.date, 'amount':'No Pagada'} 
				else:
					ppcl_browse = self.pool.get('hr_payroll_cr.payment_per_contract_line').browse(self.cr, self.uid, payment_per_contract_line[0])
					#charge the extra_hour register whit all the information
					register = {'name':name, 'contractCode':contractCode, 'amount_hours':extra_hour.hours, 'date':extra_hour.date, 'amount':ppcl_browse.amount }
				#append the register to the answere
				answ.append(register)
		#return the list of extra_hour	
		return answ
		
	def _startDate(self, form):
		date = form['dateStart']
		return str(date)
		
	def _endDate(self, form):
		date = form['dateEnd']
		return str(date)
		
	def _get_company(self, form):
		company_id = form['company_id']
		debug(company_id)
		name = self.pool.get('res.company').browse(self.cr, self.uid, company_id)
		debug(name)
		debug(name.name)
		return name.name
		

report_sxw.report_sxw('report.hr_payroll_cr.extraHourPerCompany', 'hr_payroll_cr.extra_hour', 'addons/hr_payroll_cr/report/extraHourPerCompany.rml', parser=extraHourPerCompany, header=False)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
