# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import xml
import copy
from operator import itemgetter
import time
import datetime
from report import report_sxw
import tools
from tools import debug

class grossSalary(report_sxw.rml_parse):
	_name = 'report.hr_payroll_cr.grossSalary'
	def __init__(self, cr, uid, name, context):
		super(grossSalary, self).__init__(cr, uid, name, context=context)
		self.localcontext.update({ 
			'time': time,
			'loadRegisters':self._loadRegisters,
			'month': self._month,
			'year':self._year,
			'get_company' : self._get_company,
			'get_total': self._getTotal,
		})
		
	def _loadRegisters(self, form):
		company_id = form['company_id']
		month = form['month']
		year = str(form['year'])
		#to store the answere
		answ = []
		debug(month)
		date_first = datetime.date.today()
		date_end = datetime.date.today()
		if month == '1':
			date_first = self.str2date(year+'-01-01')
			date_end = self.str2date(year+'-01-31')
		elif month == '2':
			date_first = self.str2date(year+'-02-01')
			date_end = self.str2date(year+'-02-28')
		elif month == '3':
			date_first = self.str2date(year+'-03-01')
			date_end = self.str2date(year+'-03-31')
		elif month == '4':
			date_first = self.str2date(year+'-04-01')
			date_end = self.str2date(year+'-04-30')
		elif month == '5':
			date_first = self.str2date(year+'-05-01')
			date_end = self.str2date(year+'-05-31')
		elif month == '6':
			date_first = self.str2date(year+'-06-01')
			date_end = self.str2date(year+'-06-30')
		elif month == '7':
			date_first = self.str2date(year+'-07-01')
			date_end = self.str2date(year+'-07-31')
		elif month == '8':
			date_first = self.str2date(year+'-08-01')
			date_end = self.str2date(year+'-08-31')
		elif month == '9':
			date_first = self.str2date(year+'-09-01')
			date_end = self.str2date(year+'-09-30')
		elif month == '10':
			date_first = self.str2date(year+'-10-01')
			date_end = self.str2date(year+'-10-31')
		elif month == '11':
			date_first = self.str2date(year+'-11-01')
			date_end = self.str2date(year+'-11-30')
		else:
			date_first = self.str2date(year+'-12-01')
			date_end = self.str2date(year+'-12-31')
		
		
		
		#search for all the employees of the given company
		contracts = self.pool.get('hr.contract').search(self.cr, self.uid,[('company_id','=',company_id)], order='code')
		for contract_id in contracts:
			contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)
			payment_per_contract_ids = self.pool.get('hr_payroll_cr.payment_per_contract').search(self.cr, self.uid, [('contract', '=', contract_id), ('payroll_date', '<=', str(date_end)), ('payroll_date', '>=', str(date_first))])
			debug(date_first)
			debug(date_end)
			debug(payment_per_contract_ids)
			total_gross_salary = 0
			contractCode = contract.code
			employee_id = contract.employee_id.id
			employee_browse = self.pool.get('hr.employee').browse(self.cr, self.uid, employee_id) #loads the employee register to store the employee name
			name = employee_browse.surname1 + ' ' + employee_browse.surname2 + ' ' + employee_browse.name
			employee_id_number = employee_browse.employee_id
			for ppcid in payment_per_contract_ids:
				ppc_browse = self.pool.get('hr_payroll_cr.payment_per_contract').browse(self.cr, self.uid, ppcid)
				gross = ppc_browse.gross_salary
				total_gross_salary = total_gross_salary + gross
			register = {'id_number':employee_id_number, 'name':name, 'contractCode':contractCode, 'amount':total_gross_salary} 
			answ.append(register)

		
		#return the list of extra_hour	
		return answ

	def _getTotal(self, form):
		company_id = form['company_id']
		month = form['month']
		year = str(form['year'])
		date_first = datetime.date.today()
		date_end = datetime.date.today()
		if month == '1':
			date_first = self.str2date(year+'-01-01')
			date_end = self.str2date(year+'-01-31')
		elif month == '2':
			date_first = self.str2date(year+'-02-01')
			date_end = self.str2date(year+'-02-28')
		elif month == '3':
			date_first = self.str2date(year+'-03-01')
			date_end = self.str2date(year+'-03-31')
		elif month == '4':
			date_first = self.str2date(year+'-04-01')
			date_end = self.str2date(year+'-04-30')
		elif month == '5':
			date_first = self.str2date(year+'-05-01')
			date_end = self.str2date(year+'-05-31')
		elif month == '6':
			date_first = self.str2date(year+'-06-01')
			date_end = self.str2date(year+'-06-30')
		elif month == '7':
			date_first = self.str2date(year+'-07-01')
			date_end = self.str2date(year+'-07-31')
		elif month == '8':
			date_first = self.str2date(year+'-08-01')
			date_end = self.str2date(year+'-08-31')
		elif month == '9':
			date_first = self.str2date(year+'-09-01')
			date_end = self.str2date(year+'-09-30')
		elif month == '10':
			date_first = self.str2date(year+'-10-01')
			date_end = self.str2date(year+'-10-31')
		elif month == '11':
			date_first = self.str2date(year+'-11-01')
			date_end = self.str2date(year+'-11-30')
		else:
			date_first = self.str2date(year+'-12-01')
			date_end = self.str2date(year+'-12-31')
		contracts = self.pool.get('hr.contract').search(self.cr, self.uid,[('company_id','=',company_id)], order='code')
		total_amount = 0
		for contract_id in contracts:
			contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)
			payment_per_contract_ids = self.pool.get('hr_payroll_cr.payment_per_contract').search(self.cr, self.uid, [('contract', '=', contract_id), ('payroll_date', '<=', str(date_end)), ('payroll_date', '>=', str(date_first))])
			
			for ppcid in payment_per_contract_ids:
				ppc_browse = self.pool.get('hr_payroll_cr.payment_per_contract').browse(self.cr, self.uid, ppcid)
				gross = ppc_browse.gross_salary
				total_amount = total_amount + gross
		
		return total_amount
		
	def _month(self, form):
		date = form['month']
		if date == '1':
			return 'Enero'
		elif date == '2':
			return 'Febrero'
		elif date == '3':
			return 'Marzo'
		elif date == '4':
			return 'Abril'
		elif date == '5':
			return 'Mayo'
		elif date == '6':
			return 'Junio'
		elif date == '7':
			return 'Julio'
		elif date == '8':
			return 'Agosto'
		elif date == '9':
			return 'Setiembre'
		elif date == '10':
			return 'Octubre'
		elif date == '11':
			return 'Noviembre'
		else:
			return 'Diciembre'
		
	def _year(self, form):
		date = form['year']
		return str(date)

	def str2date(self, date_str):
		date_unformat = time.strptime(date_str, '%Y-%m-%d')
		return datetime.date(date_unformat.tm_year, date_unformat.tm_mon, date_unformat.tm_mday)	
		
	def _get_company(self, form):
		company_id = form['company_id']
		debug(company_id)
		name = self.pool.get('res.company').browse(self.cr, self.uid, company_id)
		debug(name)
		debug(name.name)
		return name.name
		

report_sxw.report_sxw('report.hr_payroll_cr.grossSalary', 'hr_payroll_cr.payment_per_contract', 'addons/hr_payroll_cr/report/grossSalary.rml', parser=grossSalary, header=False)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
