# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import xml
import copy
from operator import itemgetter
import time
import datetime
from report import report_sxw
import tools
from tools import debug

class loanPerCompany(report_sxw.rml_parse):
	_name = 'report.hr_payroll_cr.loanPerCompany'
	def __init__(self, cr, uid, name, context):
		super(loanPerCompany, self).__init__(cr, uid, name, context=context)
		self.localcontext.update({ 
			'time': time,
			'total': self._get_Total,
			'startDate': self._startDate,
			'endDate': self._endDate,
			'loadRegisters':self._loadRegisters,
			'get_company': self._get_company,
			'loan_type': self._loan_type,
		})
		
	def _loadRegisters(self, form):
		company_id = form['company_id']
		#to store the answere
		answ = []
		loan_type_id = form['loan_type_id']
		debug(loan_type_id)
		#search for all the employees of the given company
		contracts = self.pool.get('hr.contract').search(self.cr, self.uid,[('company_id','=',company_id)], order='code')
		employee_list = []
		for contract_id in contracts:
			contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)#loads the contract register to store the contract name
			employee_list.append(contract.employee_id.id)
		employees = self.pool.get('hr.employee').search(self.cr, self.uid,[('id','in',employee_list)], order='surname1, surname2, name')
		debug(employees)
		loan_type_browse = self.pool.get('hr_payroll_cr.loan_type').browse(self.cr, self.uid, loan_type_id)
		loan_type = loan_type_browse.name
		loans = self.pool.get('hr_payroll_cr.loan').search(self.cr, self.uid,[('contract','in',contracts), ('start_date','>=',form['dateStart']), ('start_date','<=',form['dateEnd']), ('loan_type','=',loan_type)], order='start_date')
		
		if form['order'] == '1':
			for contract_id in contracts:
				contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)#loads the contract register to store the contract name
				contractCode = contract.code			
				employee = self.pool.get('hr.employee').browse(self.cr, self.uid, contract.employee_id.id) #loads the employee register to store the employee name
				name = employee.surname1 + ' ' + employee.surname2 + ' ' + employee.name
				
				loans = self.pool.get('hr_payroll_cr.loan').search(self.cr, self.uid,[('contract','=',contract_id), ('loan_type','=',loan_type)])
				#for each loan per contract
				for loan_id in loans:
					loan = self.pool.get('hr_payroll_cr.loan').browse(self.cr, self.uid, loan_id)#loads the loan register to store the loan data			
					loan_payment = self.pool.get('hr_payroll_cr.loan_payment').search(self.cr, self.uid,[('loan','=',loan.id), ('date','>=',form['dateStart']), ('date','<=',form['dateEnd']),])
					
					for loan_payment_id in loan_payment:
						loan_browse = self.pool.get('hr_payroll_cr.loan_payment').browse(self.cr, self.uid,loan_payment_id)
						loan_browse_payment = self.pool.get('hr_payroll_cr.payment_per_contract_line').browse(self.cr, self.uid,loan_browse.payment_per_contract_line.id)
					#charge the loan register whit all the information
						register = {'balance':loan.balance, 'name':name, 'contractCode':contractCode, 'detail':loan.detail, 'date':loan_browse.date, 'amount':loan_browse_payment.amount} 
					#append the register to the answer
						answ.append(register)
					
		elif form['order'] == '2':
			for employee_id in employees:
				contracts = self.pool.get('hr.contract').search(self.cr, self.uid,[('company_id','=',company_id),('employee_id','=',employee_id)], order='date_start, code')
				employee = self.pool.get('hr.employee').browse(self.cr, self.uid, employee_id) #loads the employee register to store the employee name
				name = employee.surname1 + ' ' + employee.surname2 + ' ' + employee.name
							
				for contract_id in contracts:
					contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)#loads the contract register to store the contract name
					contractCode = contract.code
					loans = self.pool.get('hr_payroll_cr.loan').search(self.cr, self.uid,[('contract','=',contract_id), ('loan_type','=',loan_type)], order='start_date')
					#for each loan per contract
					for loan_id in loans:
						loan = self.pool.get('hr_payroll_cr.loan').browse(self.cr, self.uid, loan_id)#loads the loan register to store the loan data
						loan_payment = self.pool.get('hr_payroll_cr.loan_payment').search(self.cr, self.uid,[('loan','=',loan.id), ('date','>=',form['dateStart']), ('date','<=',form['dateEnd'])])

						for loan_payment_id in loan_payment:
							loan_browse = self.pool.get('hr_payroll_cr.loan_payment').browse(self.cr, self.uid,loan_payment_id)
							loan_browse_payment = self.pool.get('hr_payroll_cr.payment_per_contract_line').browse(self.cr, self.uid,loan_browse.payment_per_contract_line.id)
						#charge the loan register whit all the information
							register = {'balance':loan.balance, 'name':name, 'contractCode':contractCode, 'detail':loan.detail, 'date':loan_browse.date, 'amount':loan_browse_payment.amount} 
						#append the register to the answer
							answ.append(register)
							
		else:
			for loan_id in loans:
				contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)#loads the contract register to store the contract name
				contractCode = contract.code			
				employee = self.pool.get('hr.employee').browse(self.cr, self.uid, contract.employee_id.id) #loads the employee register to store the employee name
				name = employee.surname1 + ' ' + employee.surname2 + ' ' + employee.name
				
				loan = self.pool.get('hr_payroll_cr.loan').browse(self.cr, self.uid, loan_id)#loads the loan register to store the loan data
				loan_payment = self.pool.get('hr_payroll_cr.loan_payment').search(self.cr, self.uid,[('loan','=',loan.id), ('date','>=',form['dateStart']), ('date','<=',form['dateEnd'])])

				for loan_payment_id in loan_payment:
					loan_browse = self.pool.get('hr_payroll_cr.loan_payment').browse(self.cr, self.uid,loan_payment_id)
					loan_browse_payment = self.pool.get('hr_payroll_cr.payment_per_contract_line').browse(self.cr, self.uid,loan_browse.payment_per_contract_line.id)
				#charge the loan register whit all the information
					register = {'balance':loan.balance, 'name':name, 'contractCode':contractCode, 'detail':loan.detail, 'date':loan_browse.date, 'amount':loan_browse_payment.amount} 
				#append the register to the answer
					answ.append(register)
				
		#return the list of loans	
		return answ
	
	def _get_Total(self, form):
		company_id = form['company_id']
		total = 0
		loan_type_id = form['loan_type_id']
		loan_type_browse = self.pool.get('hr_payroll_cr.loan_type').browse(self.cr, self.uid, loan_type_id)
		loan_type = loan_type_browse.name
		contracts = self.pool.get('hr.contract').search(self.cr, self.uid,[('company_id','=',company_id)], order='code')
		for contract_id in contracts:
			contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)#loads the contract register to store the contract name
			
			loans = self.pool.get('hr_payroll_cr.loan').search(self.cr, self.uid,[('contract','=',contract_id), ('loan_type','=',loan_type)])
			#for each loan per contract
			for loan_id in loans:
				loan = self.pool.get('hr_payroll_cr.loan').browse(self.cr, self.uid, loan_id)#loads the loan register to store the loan data			
				loan_payment = self.pool.get('hr_payroll_cr.loan_payment').search(self.cr, self.uid,[('loan','=',loan.id), ('date','>=',form['dateStart']), ('date','<=',form['dateEnd']),])
				
				for loan_payment_id in loan_payment:
					loan_browse = self.pool.get('hr_payroll_cr.loan_payment').browse(self.cr, self.uid,loan_payment_id)
					loan_browse_payment = self.pool.get('hr_payroll_cr.payment_per_contract_line').browse(self.cr, self.uid,loan_browse.payment_per_contract_line.id)
					total = total + loan_browse_payment.amount
		debug(total)
		return total
		
	def _startDate(self, form):
		date = form['dateStart']
		return str(date)
		
	def _endDate(self, form):
		date = form['dateEnd']
		return str(date)
		
	def _get_company(self, form):
		company_id = form['company_id']
		debug(company_id)
		name = self.pool.get('res.company').browse(self.cr, self.uid, company_id)
		debug(name)
		debug(name.name)
		return name.name
		
	def _loan_type(self, form):
		type_id = form['loan_type_id']
		type = self.pool.get('hr_payroll_cr.loan_type').browse(self.cr, self.uid, type_id)
		debug(type.name)
		return type.name
		

report_sxw.report_sxw('report.hr_payroll_cr.loanPerCompany', 'hr_payroll_cr.loan', 'addons/hr_payroll_cr/report/loanPerCompany.rml', parser=loanPerCompany, header=False)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
