# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import xml
import copy
from operator import itemgetter
import time
import datetime
from report import report_sxw
import tools
from tools import debug

class overSalaryPerCompany(report_sxw.rml_parse):
	_name = 'report.hr_payroll_cr.overSalaryPerCompany'
	def __init__(self, cr, uid, name, context):
		super(overSalaryPerCompany, self).__init__(cr, uid, name, context=context)
		self.localcontext.update({ 
			'time': time,
			'loadRegisters':self._loadRegisters,
			'startDate': self._startDate,
			'endDate': self._endDate,
		})
		
	def _loadRegisters(self, form):
		company_id = form['company_id']
		#to store the answer
		answ = []
		#search for all the employees of the given company
		contracts = self.pool.get('hr.contract').search(self.cr, self.uid,[('company_id','=',company_id)], order='code')
		employee_list = []
		for contract_id in contracts:
			contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)#loads the contract register to store the contract name
			employee_list.append(contract.employee_id.id)
			employees = self.pool.get('hr.employee').search(self.cr, self.uid,[('id','in',employee_list)], order='surname1, surname2, name')
		over_salaries = self.pool.get('hr_payroll_cr.over_salary').search(self.cr, self.uid,[('contract','in',contracts)], order='start_date')
			
			
		if form['order'] == '1':
			for contract_id in contracts:
				contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)#loads the contract register to store the contract name
				contractCode = contract.code			
				employee = self.pool.get('hr.employee').browse(self.cr, self.uid, contract.employee_id.id) #loads the employee register to store the employee name
				name = employee.surname1 + ' ' + employee.surname2 + ' ' + employee.name
				over_salaries = self.pool.get('hr_payroll_cr.over_salary').search(self.cr, self.uid,[('contract','=',contract_id)], order='start_date')
				debug(over_salaries)
				if over_salaries == []:
					registerAbs = {'name':name, 'contractCode':contractCode, 'start_date':'----', 'end_date':'----', 'detail':'No hay detalle', 'amount':'No posee sobre sueldos', 'percent':'----'}
					answ.append(registerAbs)
				else:
					over_salaries = self.pool.get('hr_payroll_cr.over_salary').search(self.cr, self.uid,[('contract','=',contract_id)], order='start_date')
					for over_salary_id in over_salaries:
						over_salary = self.pool.get('hr_payroll_cr.over_salary').browse(self.cr, self.uid, over_salary_id)#loads the over_salary register to store the over_salary data
						over_salary_payment = self.pool.get('hr_payroll_cr.over_salary_payment').search(self.cr, self.uid,[('over_salary','=',over_salary.id), ('date','>=',form['dateStart']), ('date','<=',form['dateEnd'])])			
						debug(over_salary)
						for over_salary_payment_id in over_salary_payment:
							payment_browse = self.pool.get('hr_payroll_cr.over_salary_payment').browse(self.cr, self.uid, over_salary_payment_id)
							#charge the over_salary register whit all the information
							if(over_salary.percent):
								registerAbs = {'name':name, 'contractCode':contractCode, 'start_date':over_salary.start_date, 'end_date':over_salary.end_date, 'detail':over_salary.detail, 'amount':payment_browse.amount, 'percent':'Sí'} 
							else:
								registerAbs = {'name':name, 'contractCode':contractCode, 'start_date':over_salary.start_date, 'end_date':over_salary.end_date, 'detail':over_salary.detail, 'amount':payment_browse.amount, 'percent':'No'} 
							#append the register to the answer
							answ.append(registerAbs)
					
		elif form['order'] == '2':
			for employee_id in employees:
				contracts = self.pool.get('hr.contract').search(self.cr, self.uid,[('company_id','=',company_id),('employee_id','=',employee_id)], order='date_start, code')
				employee = self.pool.get('hr.employee').browse(self.cr, self.uid, employee_id) #loads the employee register to store the employee name
				name = employee.surname1 + ' ' + employee.surname2 + ' ' + employee.name
							
				for contract_id in contracts:
					contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)#loads the contract register to store the contract name
					contractCode = contract.code

					over_salaries = self.pool.get('hr_payroll_cr.over_salary').search(self.cr, self.uid,[('contract','=',contract_id)], order='start_date')

					#for each over_salary per contract
					if over_salaries == []:
						registerAbs = {'name':name, 'contractCode':contractCode, 'start_date':'----', 'end_date':'----', 'detail':'No hay detalle', 'amount':'No posee sobre sueldos', 'percent':'----'}
						answ.append(registerAbs)
					else:
						over_salaries = self.pool.get('hr_payroll_cr.over_salary').search(self.cr, self.uid,[('contract','=',contract_id)], order='start_date')
						for over_salary_id in over_salaries:
							over_salary = self.pool.get('hr_payroll_cr.over_salary').browse(self.cr, self.uid, over_salary_id)#loads the over_salary register to store the over_salary data
							over_salary_payment = self.pool.get('hr_payroll_cr.over_salary_payment').search(self.cr, self.uid,[('over_salary','=',over_salary.id), ('date','>=',form['dateStart']), ('date','<=',form['dateEnd'])])			
							
							for over_salary_payment_id in over_salary_payment:
								payment_browse = self.pool.get('hr_payroll_cr.over_salary_payment').browse(self.cr, self.uid, over_salary_payment_id)
								#charge the over_salary register whit all the information
								if(over_salary.percent):
									registerAbs = {'name':name, 'contractCode':contractCode, 'start_date':over_salary.start_date, 'end_date':over_salary.end_date, 'detail':over_salary.detail, 'amount':payment_browse.amount, 'percent':'Sí'} 
								else:
									registerAbs = {'name':name, 'contractCode':contractCode, 'start_date':over_salary.start_date, 'end_date':over_salary.end_date, 'detail':over_salary.detail, 'amount':payment_browse.amount, 'percent':'No'} 
								#append the register to the answer
								answ.append(registerAbs)		
		else:
			if over_salaries == []:
				registerAbs = {'name':name, 'contractCode':contractCode, 'start_date':'----', 'end_date':'----', 'detail':'No hay detalle', 'amount':'No posee sobre sueldos', 'percent':'----'}
				answ.append(registerAbs)
			else:
				for contract_id in contracts:
			#for each over_salary per contract
					over_salaries = self.pool.get('hr_payroll_cr.over_salary').search(self.cr, self.uid,[('contract','=',contract_id), ('start_date','>=',form['dateStart']), ('end_date','<=',form['dateEnd'])], order='start_date')
					for over_salary_id in over_salaries:
						over_salary = self.pool.get('hr_payroll_cr.over_salary').browse(self.cr, self.uid, over_salary_id)#loads the over_salary register to store the over_salary data
						over_salary_payment = self.pool.get('hr_payroll_cr.over_salary_payment').search(self.cr, self.uid,[('over_salary','=',over_salary.id), ('date','>=',form['dateStart']), ('date','<=',form['dateEnd'])])			
						contract = self.pool.get('hr.contract').browse(self.cr, self.uid, over_salary.contract.id)#loads the contract register to store the contract name
						contractCode = contract.code				
						for over_salary_payment_id in over_salary_payment:
							payment_browse = self.pool.get('hr_payroll_cr.over_salary_payment').browse(self.cr, self.uid, over_salary_payment_id)
							#charge the over_salary register whit all the information
							if(over_salary.percent):
								registerAbs = {'name':name, 'contractCode':contractCode, 'start_date':over_salary.start_date, 'end_date':over_salary.end_date, 'detail':over_salary.detail, 'amount':payment_browse.amount, 'percent':'Sí'} 
							else:
								registerAbs = {'name':name, 'contractCode':contractCode, 'start_date':over_salary.start_date, 'end_date':over_salary.end_date, 'detail':over_salary.detail, 'amount':payment_browse.amount, 'percent':'No'} 
							#append the register to the answer
							answ.append(registerAbs)
		return answ
		
	def _startDate(self, form):
		date = form['dateStart']
		return str(date)
		
	def _endDate(self, form):
		date = form['dateEnd']
		return str(date)
		

report_sxw.report_sxw('report.hr_payroll_cr.overSalaryPerCompany', 'hr_payroll_cr.over_salary', 'addons/hr_payroll_cr/report/overSalaryPerCompany.rml', parser=overSalaryPerCompany, header=False)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
