# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import xml
import copy
from operator import itemgetter
import time
import datetime
from report import report_sxw
import tools
from tools import debug
#import rpdb2

class overSalaryPerContract(report_sxw.rml_parse):
	_name = 'report.hr_payroll_cr.overSalaryPerContract'
	def __init__(self, cr, uid, name, context):
		super(overSalaryPerContract, self).__init__(cr, uid, name, context=context)
		self.localcontext.update({ 
			'time': time,
			'loadRegisters':self._loadRegisters,
			'getLoadRegisters': self._get_load_registers,
			'startDate': self._startDate,
			'endDate': self._endDate,
		})
		
	def _loadRegisters(self, form):
		#rpdb2.start_embedded_debugger('nosecual')
		c_ids = form['contracts_ids']
		cont_ids = c_ids[0][2] #gets the ids selected in the many2many field
		contracts_ids = self.pool.get('hr.contract').search(self.cr, self.uid,[('id','in',cont_ids)], order='code, date_start')
		debug(contracts_ids)
		#to store the answere
		answ = []
		for contract_id in contracts_ids:
			contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)#loads the contract register to store the contract name
			contractCode = contract.code
			
			employee = self.pool.get('hr.employee').browse(self.cr, self.uid, contract.employee_id.id) #loads the employee register to store the employee name
			employee_name = employee.surname1 + ' ' + employee.surname2 + ' ' + employee.name
			#charge the over_salary register whit all the information
			register = {'contractCode':contractCode, 'employee_name':employee_name, 'contract_id':contract_id} 
			#append the register to the answere
			answ.append(register)
		#return the list of over_salary	
		return answ
	
	def _get_load_registers(self, contract_id, form):
		#to store the answer
		answ = []
		contract = self.pool.get('hr.contract').search(self.cr, self.uid,[('id','=',contract_id)], order='code, date_start')
		#for each over_salary per contract
		over_salaries = self.pool.get('hr_payroll_cr.over_salary').search(self.cr, self.uid,[('contract','=',contract_id),('start_date','>=',form['dateStart']), ('end_date','<=',form['dateEnd'])], order='start_date')
		if over_salaries == []:
			register = {'start_date':'---', 'end_date':'---', 'detail':'No posee Sobre Salarios', 'amount':'---', 'percent':'---'} 
			answ.append(register)
		else:
			for over_salary_id in over_salaries:
				over_salary = self.pool.get('hr_payroll_cr.over_salary').browse(self.cr, self.uid, over_salary_id)#loads the over_salary register to store the over_salary data
				over_salary_payment = self.pool.get('hr_payroll_cr.over_salary_payment').search(self.cr, self.uid,[('over_salary','=',over_salary.id), ('date','>=',form['dateStart']), ('date','<=',form['dateEnd']),])			
				
				for over_salary_payment_id in over_salary_payment:
					payment_browse = self.pool.get('hr_payroll_cr.over_salary_payment').browse(self.cr, self.uid, over_salary_payment_id)
					if payment_browse:
						#charge the over_salary register whit all the information
						debug(payment_browse)
						debug(payment_browse.payment_per_contract_line)
						if(over_salary.percent):
							register = {'start_date':over_salary.start_date, 'end_date':over_salary.end_date, 'detail':over_salary.detail, 'amount':payment_browse.amount, 'percent':'Sí'} 
						else:
							register = {'start_date':over_salary.start_date, 'end_date':over_salary.end_date, 'detail':over_salary.detail, 'amount':payment_browse.amount, 'percent':'No'} 
						#append the register to the answer
						answ.append(register)
			#return the list of over_salary	
		return answ
		
	def _startDate(self, form):
		date = form['dateStart']
		return str(date)
		
	def _endDate(self, form):
		date = form['dateEnd']
		return str(date)
		

report_sxw.report_sxw('report.hr_payroll_cr.overSalaryPerContract', 'hr_payroll_cr.over_salary', 'addons/hr_payroll_cr/report/overSalaryPerContract.rml', parser=overSalaryPerContract, header=False)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
