# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import xml
import copy
from operator import itemgetter
import time
import datetime
from report import report_sxw
import tools
from tools import debug

class savingPerCompanyTotal(report_sxw.rml_parse):
	_name = 'report.hr_payroll_cr.savingPerCompanyTotal'
	def __init__(self, cr, uid, name, context):
		super(savingPerCompanyTotal, self).__init__(cr, uid, name, context=context)
		self.localcontext.update({ 
			'time': time,
			'total':self._get_Total,
			'start_date': self._date_start,
			'end_date': self._date_end,
			'saving_type': self._saving_type,
			'get_company': self._get_company,
			'loadRegisters':self._loadRegisters,
		})
		
	def _loadRegisters(self, form):
		company_id = form['company_id']
		saving_type_id = form['saving_type']
		#to store the answer
		answ = []
		date_start = self._date_start(form)
		date_end = self._date_end(form)
		#search for all the employees of the given company
		contracts = self.pool.get('hr.contract').search(self.cr, self.uid,[('company_id','=',company_id)], order='code')
		employee_list = []
		for contract_id in contracts:
			contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)#loads the contract register to store the contract name
			employee_list.append(contract.employee_id.id)
		employees = self.pool.get('hr.employee').search(self.cr, self.uid,[('id','in',employee_list)], order='surname1, surname2, name')
		savings = self.pool.get('hr_payroll_cr.saving').search(self.cr,self.uid,[('contract','in',contracts),('start_date','>=',date_start),('end_date','<=',date_end)],order='start_date')
		if form['order'] == '1':
			for contract_id in contracts:
				contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)#loads the contract register to store the contract name
				contractCode = contract.code			
				employee = self.pool.get('hr.employee').browse(self.cr, self.uid, contract.employee_id.id) #loads the employee register to store the employee name
				name = employee.surname1 + ' ' + employee.surname2 + ' ' + employee.name
				savings = self.pool.get('hr_payroll_cr.saving_type').browse(self.cr,self.uid,saving_type_id)
				saving = self.pool.get('hr_payroll_cr.saving').search(self.cr , self.uid, [('contract','=',contract_id), ('type','=',saving_type_id)])
				saving_total_amount = 0
				for s_id in saving:
					saving_browse = self.pool.get('hr_payroll_cr.saving').browse(self.cr, self.uid, s_id)
					saving_line = self.pool.get('hr_payroll_cr.saving_quota').search(self.cr, self.uid,[('saving','=',s_id), ('date','>=',form['dateStart']), ('date','<=',form['dateEnd'])])
					for saving_line_id in saving_line:
						saving_line_browse = self.pool.get('hr_payroll_cr.saving_quota').browse(self.cr, self.uid, saving_line_id)
						payment_per_contract_line = self.pool.get('hr_payroll_cr.payment_per_contract_line').search(self.cr,self.uid, [('id','=',saving_line_browse.payment_per_contract_line.id)])
						for ppcl_id in payment_per_contract_line:
							payment_per_contract_line_browse = self.pool.get('hr_payroll_cr.payment_per_contract_line').browse(self.cr,self.uid, ppcl_id)
							saving_total_amount += payment_per_contract_line_browse.amount
				if(saving_total_amount != 0):
					register = {'name':name, 'contractCode':contractCode, 'total': saving_total_amount} 
					#append the register to the answer
					answ.append(register)
		elif form['order'] == '2':
			for employee_id in employees:
				contracts = self.pool.get('hr.contract').search(self.cr, self.uid,[('company_id','=',company_id),('employee_id','=',employee_id)], order='date_start, code')
				employee = self.pool.get('hr.employee').browse(self.cr, self.uid, employee_id) #loads the employee register to store the employee name
				name = employee.surname1 + ' ' + employee.surname2 + ' ' + employee.name
				for contract_id in contracts:
					contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)#loads the contract register to store the contract name
					contractCode = contract.code
					savings = self.pool.get('hr_payroll_cr.saving_type').browse(self.cr,self.uid,saving_type_id)
					saving = self.pool.get('hr_payroll_cr.saving').search(self.cr , self.uid, [('contract','=',contract_id), ('type','=',saving_type_id)])
					saving_total_amount = 0
					for s_id in saving:
						saving_browse = self.pool.get('hr_payroll_cr.saving').browse(self.cr, self.uid, s_id)
						saving_line = self.pool.get('hr_payroll_cr.saving_quota').search(self.cr, self.uid,[('saving','=',s_id), ('date','>=',form['dateStart']), ('date','<=',form['dateEnd'])])
						for saving_line_id in saving_line:
							saving_line_browse = self.pool.get('hr_payroll_cr.saving_quota').browse(self.cr, self.uid, saving_line_id)
							payment_per_contract_line = self.pool.get('hr_payroll_cr.payment_per_contract_line').search(self.cr,self.uid, [('id','=',saving_line_browse.payment_per_contract_line.id)])
							for ppcl_id in payment_per_contract_line:
								payment_per_contract_line_browse = self.pool.get('hr_payroll_cr.payment_per_contract_line').browse(self.cr,self.uid, ppcl_id)
								saving_total_amount += payment_per_contract_line_browse.amount
					if(saving_total_amount != 0):
						register = {'name':name, 'contractCode':contractCode, 'total': saving_total_amount} 
						#append the register to the answer
						answ.append(register)
		#return the list of savings
		return answ
	
	def _get_Total(self, form):
		company_id = form['company_id']
		saving_type_id = form['saving_type']
		total = 0
		date_start = self._date_start(form)
		date_end = self._date_end(form)
		#search for all the employees of the given company
		contracts = self.pool.get('hr.contract').search(self.cr, self.uid,[('company_id','=',company_id)], order='code')
		for contract_id in contracts:
			contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)#loads the contract register to store the contract name
			savings = self.pool.get('hr_payroll_cr.saving_type').browse(self.cr,self.uid,saving_type_id)
			
			saving = self.pool.get('hr_payroll_cr.saving').search(self.cr , self.uid, [('contract','=',contract_id), ('type','=',saving_type_id)])
			for s_id in saving:
				saving_browse = self.pool.get('hr_payroll_cr.saving').browse(self.cr, self.uid, s_id)
				saving_line = self.pool.get('hr_payroll_cr.saving_quota').search(self.cr, self.uid,[('saving','=',s_id), ('date','>=',form['dateStart']), ('date','<=',form['dateEnd'])])
				for saving_line_id in saving_line:
					saving_line_browse = self.pool.get('hr_payroll_cr.saving_quota').browse(self.cr, self.uid, saving_line_id)
					payment_per_contract_line = self.pool.get('hr_payroll_cr.payment_per_contract_line').search(self.cr,self.uid, [('id','=',saving_line_browse.payment_per_contract_line.id)])
					for ppcl_id in payment_per_contract_line:
						payment_per_contract_line_browse = self.pool.get('hr_payroll_cr.payment_per_contract_line').browse(self.cr,self.uid, ppcl_id)
						total = total + payment_per_contract_line_browse.amount
		return total	
		
	def _date_start(self, form):
		date = form['dateStart']
		return date

	def _date_end(self, form):
		date = form['dateEnd']
		return date
		
	def _saving_type(self, form):
		type_id = form['saving_type']
		type = self.pool.get('hr_payroll_cr.saving_type').browse(self.cr, self.uid, type_id)
		debug(type.name)
		return type.name
		
	def _get_company(self, form):
		company_id = form['company_id']
		debug(company_id)
		name = self.pool.get('res.company').browse(self.cr, self.uid, company_id)
		debug(name)
		debug(name.name)
		return name.name	
		

report_sxw.report_sxw('report.hr_payroll_cr.savingPerCompanyTotal', 'hr_payroll_cr.saving', 'addons/hr_payroll_cr/report/savingPerCompanyTotal.rml', parser=savingPerCompanyTotal, header=False)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
