# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import xml
import copy
from operator import itemgetter
import time
import datetime
from report import report_sxw
import tools
from tools import debug
#####
#TODO
#Apply boolean to hide quotas
#####
class savingPerContract(report_sxw.rml_parse):
	_name = 'report.hr_payroll_cr.savingPerContract'
	def __init__(self, cr, uid, name, context):
		super(savingPerContract, self).__init__(cr, uid, name, context=context)
		self.localcontext.update({ 
			'time': time,
			'total':self._get_total,
			'loadRegisters':self._loadRegisters,
			'getLoadRegisters': self._get_load_registers,
			'startDate': self._startDate,
			'endDate': self._endDate,
			'quotas': self._quotas
		})
		
	def _loadRegisters(self, form):
		contracts_ids = form['contracts_ids']
		contracts_ids = contracts_ids[0][2] #gets the ids selected in the many2many field
		contracts_ids = self.pool.get('hr.contract').search(self.cr, self.uid,[('id','in',contracts_ids)], order='code, date_start')
		#to store the answer
		answ = []
		for contract_id in contracts_ids:
			contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)#loads the contract register to store the contract name
			contractCode = contract.code
			
			employee = self.pool.get('hr.employee').browse(self.cr, self.uid, contract.employee_id.id) #loads the employee register to store the employee name
			employee_name = employee.surname1 + ' ' + employee.surname2 + ' ' + employee.name
			#charge the over_salary register whit all the information
			registerAbs = {'contractCode':contractCode, 'employee_name':employee_name, 'contract_id':contract_id} 
			#append the register to the answer
			answ.append(registerAbs)
		#return the list of over_salary	
		return answ
	
	def _get_load_registers(self, contract_id, form):
		#to store the answer
		answ = []
		contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)#loads the contract register to store the contract name
		#search for each savings per contract
		savings = self.pool.get('hr_payroll_cr.saving').search(self.cr, self.uid,[('contract','=',contract_id), ('start_date','>=',form['dateStart']), ('end_date','<=',form['dateEnd'])], order='start_date')
		if savings == []:
			registerSav = {'start_date':'---', 'end_date':'---', 'detail':'No posee ahorros', 'quota':'---', 'total':'---'}
			answ.append(registerSav)
		for saving_id in savings:
			saving = self.pool.get('hr_payroll_cr.saving').browse(self.cr, self.uid, saving_id)#loads the over_salary register to store the over_salary data
			#charge the saving register with all the information
			registerSav = {'detail':saving.detail, 'start_date':saving.start_date, 'end_date':saving.end_date, 'quota':saving.quota, 'total':saving.total, 'saving_id':saving_id} 
			#append the register to the answer
			answ.append(registerSav)
		#return the list of savings
		return answ
	
	def _get_total(self, contract_id, form):
		
		contract = self.pool.get('hr.contract').browse(self.cr, self.uid, contract_id)#loads the contract register to store the contract name
		#search for each savings per contract
		savings = self.pool.get('hr_payroll_cr.saving').search(self.cr, self.uid,[('contract','=',contract_id), ('start_date','>=',form['dateStart']), ('end_date','<=',form['dateEnd'])], order='start_date')
		total = 0
		for saving_id in savings:
			saving = self.pool.get('hr_payroll_cr.saving').browse(self.cr, self.uid, saving_id)#loads the over_salary register to store the over_salary data
			#charge the saving register with all the information
			total = total + quota
		#return the list of savings
		return total
	
	def _quotas(self, saving_id, form):
		answ = [] # to store the answer
		#search of all the quotas of a saving
		saving_id_quota = self.pool.get('hr_payroll_cr.saving_quota').search(self.cr,self.uid, ['saving', '=', saving_id])
		for s_i_q in saving_id_quota:
			# loads information for each quota
			saving_quota = self.pool.get('hr_payroll_cr.saving_quota').browse(self.cr,self.uid,saving_id_quota)
			# store the information
			registerSQ = {'quota': quota, 'total': total, 'date': date}
			answ.append(registerSQ)
		return answ # return the list of the quotas
		
	def _startDate(self, form):
		date = form['dateStart']
		return str(date)
		
	def _endDate(self, form):
		date = form['dateEnd']
		return str(date)
		

report_sxw.report_sxw('report.hr_payroll_cr.savingPerContract', 'hr_payroll_cr.saving', 'addons/hr_payroll_cr/report/savingPerContract.rml', parser=savingPerContract, header=False)
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
