# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time
import wizard
import pooler

_form_init = '''<?xml version="1.0"?>
<form string="Deduction Report: Select the Total or Detailed Deduction Per Company Report">
</form>'''
_fields_init = {}

_form = '''<?xml version="1.0"?>
<form string="Deduction Report: Select the Company and Dates to filter">
	<field name="company_id"/>
	<field name="deduction_type"/>
	<newline/>
	<field name="month"/>
	<field name="year"/>
	<field name="order"/>
</form>'''
_fields = {
	'company_id': {'string': 'Company', 'type': 'many2one', 'relation': 'res.company', 'required': True},
	'month': {'string': 'Month:', 'type':'selection', 'selection': [('1','January'),
																	('2','February'),
																	('3','March'),
																	('4','April'),
																	('5','May'),
																	('6','June'),
																	('7','July'),
																	('8','August'),
																	('9','September'),
																	('10','October'),
																	('11','November'),
																	('12','December')],
																	 'required':True, 'default': lambda *a:"January",},
    'year': {'string':"Year",'type':'integer','required':True, 'default': lambda *a: '2010'},
    'deduction_type': {'string': 'Deduction Type', 'type': 'many2one', 'relation': 'hr_payroll_cr.deduction_type', 'required': True},
    'order': {'string': 'Order by:', 'type':'selection', 'selection': [('1','Contract'),('2','Employee'),('3','Date')], 'required':True, 'default': lambda *a:"Contract",}
    }
_fields_total = {
	'company_id': {'string': 'Company', 'type': 'many2one', 'relation': 'res.company', 'required': True},
	'month': {'string': 'Month:', 'type':'selection', 'selection': [('1','January'),
																	('2','February'),
																	('3','March'),
																	('4','April'),
																	('5','May'),
																	('6','June'),
																	('7','July'),
																	('8','August'),
																	('9','September'),
																	('10','October'),
																	('11','November'),
																	('12','December')],
																	 'required':True, 'default': lambda *a:"January",},
    'year': {'string':"Year",'type':'integer','required':True, 'default': lambda *a: '2010'},
    'deduction_type': {'string': 'Deduction Type', 'type': 'many2one', 'relation': 'hr_payroll_cr.deduction_type', 'required': True},
    'order': {'string': 'Order by:', 'type':'selection', 'selection': [('1','Contract'),('2','Employee')], 'required':True, 'default': lambda *a:"Contract",}
    }



class wizard_deduction_per_company(wizard.interface):

	states = {
		'init': {
			'actions': [],
			'result': {
				'type': 'form',
				'arch': _form_init,
				'fields': _fields_init,
				'state': [
					('end', 'Cancel'),
					('total', 'Total Deduction Per Company'),
					('detail', 'Detailed Deduction Per Company')
				]
			}
		},
		'total': {
			'actions': [],
			'result': {
				'type': 'form',
				'arch': _form,
				'fields': _fields_total,
				'state': [
					('end', 'Cancel'),
					('total_print', 'Print: Total Deduction Per Company')
				]
			}
		},
		'detail': {
			'actions': [],
			'result': {
				'type': 'form',
				'arch': _form,
				'fields': _fields,
				'state': [
					('end', 'Cancel'),
					('detail_print', 'Print: Detailed Deduction Per Company')
				]
			}
		},
		'total_print': {
			'actions': [],
			'result': {
				'type': 'print',
				'report': 'hr_payroll_cr.deductionPerCompanyTotal',
				'state':'end'
			}
		},
		'detail_print': {
			'actions': [],
			'result': {
				'type': 'print',
				'report': 'hr_payroll_cr.deductionPerCompany',
				'state':'end'
			}
		}
	}

wizard_deduction_per_company('hr_payroll_cr.wizard_deduction_per_company')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
