# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time
import wizard
import pooler
import datetime

_form = '''<?xml version="1.0"?>
<form string="Gross Salary Report: Select the Company and month">
	<field name="company_id"/>
	<newline/>
	<field name="month"/>
	<field name="year"/>
	
</form>'''

_fields = {
	'company_id': {'string': 'Company', 'type': 'many2one', 'relation': 'res.company', 'required': True},	
    'month':{'string': 'Month', 'type': 'selection', 'selection': [('1', 'January'), ('2', 'February'), ('3', 'March'), ('4', 'April'), ('5', 'May'), ('6', 'June'), ('7', 'July'), ('8', 'August'), ('9', 'September'), ('10', 'October'), ('11', 'November'), ('12', 'December')], 'required':True, 'default': lambda *a:'January',},
    'year':{'string':'Year', 'type':'integer', 'required':True, 'default':lambda *a:datetime.date.today().year}
    }


class wizard_gross_salary_per_company(wizard.interface):

	states = {
		'init': {
			'actions': [],
			'result': {
				'type': 'form',
				'arch': _form,
				'fields': _fields,
				'state': [
					('end', 'Cancel'),
					('report', 'Print Report.')
				]
			}
		},
		'report': {
			'actions': [],
			'result': {
				'type': 'print',
				'report': 'hr_payroll_cr.grossSalary',
				'state':'end'
			}
		}
	}

wizard_gross_salary_per_company('hr_payroll_cr.wizard_gross_salary_per_company')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
