# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time
import wizard
import pooler

_form_init = '''<?xml version="1.0"?>
<form string="Incapacity Period Report: Select the report type">
</form>'''
_fields_init = {}

_form = '''<?xml version="1.0"?>
<form string="Incapacity Period Report: Select the Dates and the contracts to filter">
	<field name="company_id"/>
	<newline/>
	<field name="dateStart"/>
	<field name="dateEnd"/>	
	<newline/>
	<field name="order"/>
</form>'''

_fields = {
	'company_id': {'string': 'Company', 'type': 'many2one', 'relation': 'res.company', 'required': True},
    'dateStart': {'string':"Start date",'type':'date','required':True, 'default': lambda *a: time.strftime('%Y-%m-%d')},    
    'dateEnd': {'string':"End date",'type':'date','required':True, 'default': lambda *a: time.strftime('%Y-%m-%d')},
    'order': {'string': 'Order by', 'type':'selection', 'selection': [('1','Contract'),('2','Employee'),('3','Date')], 'required':True, 'default': lambda *a:"Contract",},
}

_fields_total = {
	'company_id': {'string': 'Company', 'type': 'many2one', 'relation': 'res.company', 'required': True},	
    'dateStart': {'string':"Start date",'type':'date','required':True, 'default': lambda *a: time.strftime('%Y-%m-%d')},    
    'dateEnd': {'string':"End date",'type':'date','required':True, 'default': lambda *a: time.strftime('%Y-%m-%d')},
	'order': {'string': 'Order by:', 'type':'selection', 'selection': [('1','Contract'),('2','Employee')], 'required':True, 'default': lambda *a:"Contract",},
}

class wizard_incapacity_period_per_company(wizard.interface):
	states = {
		'init': {
			'actions': [],
			'result': {
				'type': 'form',
				'arch': _form_init,
				'fields': _fields_init,
				'state': [
					('end', 'Cancel'),
					('total', 'Incapacity Period Total Per Company'),
					('detail', 'Incapacity Period Detailed Per Company')
				]
			}
		},
		'total': {
			'actions': [],
			'result': {
				'type': 'form',
				'arch': _form,
				'fields': _fields_total,
				'state': [
					('end', 'Cancel'),
					('total_print', 'Print: Incapacity Period Total Per Company')
				]
			}
		},
		'detail': {
			'actions': [],
			'result': {
				'type': 'form',
				'arch': _form,
				'fields': _fields,
				'state': [
					('end', 'Cancel'),
					('detail_print', 'Print: Incapacity Period Detailed Per Company')
				]
			}
		},
		'total_print': {
			'actions': [],
			'result': {
				'type': 'print',
				'report': 'hr_payroll_cr.incapacityPeriodPerCompanyTotal',
				'state':'end'
			}
		},
		'detail_print': {
			'actions': [],
			'result': {
				'type': 'print',
				'report': 'hr_payroll_cr.incapacityPeriodPerCompany',
				'state':'end'
			}
		}
	}

wizard_incapacity_period_per_company('hr_payroll_cr.wizard_incapacity_period_per_company')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
