# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time
import wizard
import pooler
from tools import debug

_form = '''<?xml version="1.0"?>
<form string="Payroll Creation: Select the creation method">
</form>
'''
_fields = {}
#Form and Fields for payroll per company
_form_1 = '''<?xml version="1.0"?>
<form string="Payroll Creation: Select the fields and press the button">
	<field name="date"/>
	<field name="detail"/>
	<newline/>

	<field name="payroll_type"/>
	<newline/>
	<field name="contract_id" colspan="4"/>
</form>'''

_fields_1 = {
    'date': {'string':"Date",'type':'date','required':True, 'default': lambda *a: time.strftime('%Y-%m-%d')},
    'detail': {'string':"Detail",'type':'char','required':True},
    
	'payroll_type': {'string': 'Payroll Type', 'type': 'selection', 'selection':[('U', 'Unemployment Fee'), 
																				('F', 'Final Payment'),
																				('P', 'Payroll')] , 
																			'required': True, 'default': lambda *a:"January",},
	'contract_id': {'string': 'Contractos', 'type': 'many2many', 'relation': 'hr.contract', 'required': True},
    }

# Form and Fields for payroll per contract
_form_2 = '''<?xml version="1.0"?>
<form string="Payroll Creation: Select the fields and press the button">
	<field name="date"/>
	<field name="detail"/>
	<newline/>
	<field name="company_id"/>
	<field name="payroll_type"/>
</form>'''

_fields_2 = {
    'date': {'string':"Date",'type':'date','required':True, 'default': lambda *a: time.strftime('%Y-%m-%d')},
    'detail': {'string':"Detail",'type':'char','required':True},
    'company_id': {'string': 'Company', 'type': 'many2one', 'relation': 'res.company', 'required': True},
	'payroll_type': {'string': 'Payroll Type', 'type': 'selection', 'selection':[
																				('P', 'Payroll'),
																				('FC', 'Unemployment fee per Company'),
																				('C', 'Christmas Bonus')
																				] , 
																			'required': True, 'default': lambda *a:"January",},
    }

def contract(self, cr, uid, data, context):
	pool= pooler.get_pool(cr.dbname)
	payroll_ids = data['ids']
	date = data['form']['date']
	detail = data['form']['detail']

	payroll_type = data['form']['payroll_type']
	contract_ids = data['form']['contract_id']
	pool.get('hr_payroll_cr.payroll')._whole_payroll(cr, uid, payroll_ids, date, detail, 0, payroll_type, contract_ids[0][2], True, context) # contract_ids has the form (int, int, [contract_ids]) then the position [0][2] has the ids that are needed
	return data['form']

def company(self, cr, uid, data, context):
	pool= pooler.get_pool(cr.dbname)
	payroll_ids = data['ids']
	date = data['form']['date']
	detail = data['form']['detail']
	company_id = data['form']['company_id']
	payroll_type = data['form']['payroll_type']
	pool.get('hr_payroll_cr.payroll')._whole_payroll(cr, uid, payroll_ids, date, detail, company_id, payroll_type, None, False, context)
	return data['form']
class wizard_payroll_creation(wizard.interface):

	states = {
		'init': {
			'actions': [],
			'result': {
				'type': 'form',
				'arch': _form,
				'fields': _fields,
				'state': [ ('end', 'Cancel'), ('company', 'Payroll per Company') , ('contract', 'Payroll per Contract') ]
			}
		},
		'company': {
			'actions':[],
			'result': {
				'type':'form',
				'arch': _form_2,
				'fields': _fields_2,
				'state': [ ('end', 'Cancel'), ('company_1', 'Calculate Payroll per Company') ]
			}
		},
		'contract': {
			'actions':[],
			'result': {
				'type':'form',
				'arch': _form_1,
				'fields': _fields_1,
				'state': [ ('end', 'Cancel'), ('contract_1', 'Calculate Payroll per Contract') ]
			}
		},
		'company_1': {
			'actions': [company],
			'result': {
				'type': 'state',
				'state':'end'
			}
		},
		'contract_1': {
			'actions': [contract],
			'result': {
				'type': 'state',
				'state':'end'
			}
		}
	}

wizard_payroll_creation('hr_payroll_cr.wizard_payroll_creation')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
