# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time
import wizard
import pooler

_form = '''<?xml version="1.0"?>
<form string="Payroll: Select the Company and Dates to filter">
	<field name="company_id"/>
	<newline/>
	<field name="dateStart"/>
	<field name="dateEnd"/>
	<field name="order"/>
	
</form>'''

_fields = {
	'company_id': {'string': 'Company', 'type': 'many2one', 'relation': 'res.company', 'required': True},	
    'dateStart': {'string':"Start date",'type':'date','required':True, 'default': lambda *a: time.strftime('%Y-%m-%d')},    
    'dateEnd': {'string':"End date",'type':'date','required':True, 'default': lambda *a: time.strftime('%Y-%m-%d')},
    'order': {'string': 'Order by:', 'type':'selection', 'selection': [('1','Contract'),('2','Employee')], 'required':True, 'default': lambda *a:"Contract",}
    }


class wizard_payroll_per_contract(wizard.interface):

	states = {
		'init': {
			'actions': [],
			'result': {
				'type': 'form',
				'arch': _form,
				'fields': _fields,
				'state': [
					('end', 'Cancel'),
					('report', 'Print Report.')
				]
			}
		},
		'report': {
			'actions': [],
			'result': {
				'type': 'print',
				'report': 'hr_payroll_cr.payrollPerContract',
				'state':'end'
			}
		}
	}

wizard_payroll_per_contract('hr_payroll_cr.wizard_payroll_per_contract')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
